*DECK DRAGON
      PROGRAM DRAGON
      IMPLICIT         NONE
C----
C  INPUT/OUTPUT UNITS
C----
      INTEGER          IINP,IOUT
      CHARACTER        NAMSBR*6
      PARAMETER       (IINP=5,IOUT=6,NAMSBR='DRAGON')
C----
C  MEMORY ALLOCATION
C----
      INTEGER          IBASE(1)
      REAL             RBASE
      COMMON           RBASE(1)
      EQUIVALENCE     (RBASE(1),IBASE(1))
      INTEGER          IC0,IC1,IC2
C----
C  VARIABLES FOR DRAGON VERSION
C----
      INTEGER          IMVERS,ISVERS,IVDATE(3),IYMD
C----
C  VARIABLES FOR DATA STRUCTURES
C----
      INTEGER          MAXENT
      PARAMETER       (MAXENT=64)
      CHARACTER        HENTRY(MAXENT)*12
      INTEGER          IENTRY(MAXENT),JENTRY(MAXENT),KENTRY(MAXENT)
C----
C  GAN-2000 PARAMETERS
C----
      INTEGER          CLECST
      EXTERNAL         CLECST
      INTEGER          KERNEL
C----
C  DIMENSION FOR MODULE DATA
C----
      INTEGER          NMODXT
      PARAMETER       (NMODXT=18)
      CHARACTER        CMODXT(NMODXT)*12
C----
C  DIMENSION FOR BICKLEY AND EXPONENTIAL FUNCTIONS
C----
      INTEGER          NBX,NBEX,NBICK
      DOUBLE PRECISION DX,DEX
      PARAMETER       (DX=0.02D0,NBX=600,NBICK=5,DEX=1.D0/512.D0,
     >                 NBEX=7936)
      INTEGER          IBICL,IEXP,MLOG(NBICK)
C----
C  LOCAL VARIABLES
C----
      CHARACTER        NAMOUT*20
      INTEGER          IMODUL,NENTRY,ILEVEL,IPRINT,IOS,IBLANK
C----
C  DATA
C----
      SAVE             IBICL,IEXP,MLOG,CMODXT
      DATA             IBICL
     >                /0/
      DATA             IEXP
     >                /0/
      DATA            MLOG
     >                /30,15,0,0,0/
      DATA             CMODXT
     >   /'ASM:        ','CFC:        ','CPO:        ','EDI:        ',
     >    'EVO:        ','EXCELL:     ','EXCELT:     ','FLU:        ',
     >    'GEO:        ','INFO:       ','JPMT:       ','LIB:        ',
     >    'MAC:        ','MOCC:       ','MRG:        ','PSP:        ',
     >    'SHI:        ','SYBILT:     '/
C----
C  VARIABLES INITIALISATION
C----
      NAMOUT=' '
      IMODUL=0
      NENTRY=0
      ILEVEL= 0
      IPRINT= 0
      IOS=0
      IBLANK=0
C----
C  FOR INPUT/OUTPUT FILE ON MAC
C
C      OPEN(UNIT=IINP,FILE="",STATUS='OLD',
C     >     FORM='FORMATTED',IOSTAT=IOS)
C      INQUIRE(UNIT=IINP,NAME=NAMOUT)
C      WRITE(IOUT,*) 'INPUT FILE IS : ',NAMOUT
C      IBLANK=INDEX(NAMOUT,' ')
C      NAMOUT=NAMOUT(1:IBLANK-1)//'+'
C      WRITE(IOUT,*) 'OUTPUT FILE IS : ',NAMOUT
C      OPEN(UNIT=IOUT,FILE=NAMOUT,FORM='FORMATTED',IOSTAT=IOS)
C      REWIND(IOUT)
C
C  END INPUT/OUTPUT FILE ON MAC
C----
      CALL XDRVER(IMVERS,ISVERS,IVDATE)
      WRITE(IOUT,6000) NAMSBR,IMVERS,ISVERS,(IVDATE(IYMD),IYMD=1,3)
C----
C  COMMENT FOR PARTIAL UPDATE
C----
      IVDATE(1)=2001
      IVDATE(2)=4
      IVDATE(3)=6
      WRITE(IOUT,6001) NAMSBR,IMVERS,ISVERS,'b',
     >                (IVDATE(IYMD),IYMD=1,3)
      WRITE(IOUT,6010) NAMSBR
C----
C  INITIALIZE COMMON BLOCKS FOR BICKLEY FUNCTIONS
C----
      IF(IBICL .EQ. 0) THEN
        CALL SETARA(RBASE,2*NBICK*(NBX+1),IC0)
        CALL SETARA(RBASE,2*NBICK*(NBX+1),IC1)
        CALL SETARA(RBASE,2*NBICK*(NBX+1),IC2)
        CALL XDRKIN(DX,NBX,MLOG,RBASE(IC0),RBASE(IC1),RBASE(IC2))
        CALL RLSARA(RBASE(IC2))
        CALL RLSARA(RBASE(IC1))
        CALL RLSARA(RBASE(IC0))
        IBICL=1
      ENDIF
C----
C  INITIALIZE COMMON BLOCK FOR EXPONENTIAL FUNCTION
C----
      IF(IEXP .EQ. 0) THEN
        CALL XDREXP(DEX,NBEX)
        IEXP=1
      ENDIF
C----
C  WHILE LOOP UNTIL ILEVEL = 0
C----
 100  CONTINUE
        IMODUL= KERNEL(CMODXT,NMODXT,ILEVEL,MAXENT,
     >                 CLECST,IPRINT,
     >                 NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
C----
C  RUN FINISHED IF ILEVEL = 0
C----
        IF(ILEVEL .EQ. 0) GO TO 105
        IF(IMODUL .LE. 0 .OR. IMODUL .GT. NMODXT) THEN
C----
C  ILLEGAL VALUE FOR IMODUL RETURNED
C  RETURN VALUE OF IMODUL AND ABORT
C----
          WRITE(IOUT,9000) NAMSBR,IMODUL
          CALL XABORT(NAMSBR//': KERNEL ERROR')
        ELSE
C----
C  CALL APPROPRIATE MODULE
C----
          IF(      IMODUL .EQ.  1 ) THEN
            CALL ASM   (NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ.  2 ) THEN
            CALL CFC   (NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ.  3 ) THEN
            CALL CPO   (NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ.  4 ) THEN
            CALL EDI   (NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ.  5 ) THEN
            CALL EVO   (NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ.  6 ) THEN
            CALL XL3   (NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ.  7 ) THEN
            CALL EXCELT(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ.  8 ) THEN
            CALL FLU   (NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ.  9 ) THEN
            CALL GEO   (NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ. 10 ) THEN
            CALL INF   (NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ. 11 ) THEN
            CALL JPMT  (NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ. 12 ) THEN
            CALL LIB   (NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ. 13 ) THEN
            CALL MAC   (NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ. 14 ) THEN
            CALL MOC   (NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ. 15 ) THEN
            CALL MRG   (NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ. 16 ) THEN
            CALL PSP   (NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ. 17 ) THEN
            CALL SHI   (NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ. 18 ) THEN
            CALL SYBILT(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ENDIF
C----
C  GO TO PROCESS NEXT MODULE
C----
        ENDIF
      GO TO 100
C----
C  ALL MODULES PROCESSED
C----
 105  CONTINUE
      WRITE(IOUT,6030) NAMSBR,IMVERS,ISVERS
      STOP
C----
C  FORMATS
C----
 6000 FORMAT(
     > ' DDDDDD   RRRRRR     AAA     GGGGG    OOOOO   NN     NN'/
     > ' DDDDDDD  RRRRRRR   AAAAA   GGGGGGG  OOOOOOO  NNN    NN'/
     > ' DD   DD  RR   RR  AA   AA  GG       OO   OO  NNNN   NN'/
     > ' DD   DD  RRRRRR   AA   AA  GG  GGG  OO   OO  NN NN  NN'/
     > ' DD   DD  RRRR     AAAAAAA  GG  GGG  OO   OO  NN  NN NN'/
     > ' DD   DD  RR RR    AAAAAAA  GG   GG  OO   OO  NN   NNNN'/
     > ' DDDDDDD  RR  RR   AA   AA  GGGGGGG  OOOOOOO  NN    NNN'/
     > ' DDDDDD   RR   RR  AA   AA   GGGGG    OOOOO   NN     NN'//
     > ' VERSION ',A6,I2,'.',I2.2,' (',I4,'/',I2.2,'/',I2.2,')'/
     > ' GROUPE D''ANALYSE NUCLEAIRE'/
     > ' ECOLE POLYTECHNIQUE DE MONTREAL'///)
 6001 FORMAT(' You are now using ',A6,1X,I2,'.',I2.2,
     >       ' Revision ',A1,' (',I4,'/',I2.2,'/',I2.2,')'//)
 6010 FORMAT(
     > ' COPYRIGHT NOTICE FOR THIS VERSION OF ',A6,':'/
     > ' --------------------------------------------'/
     > ' PERMISSION IS GRANTED TO THE PUBLIC TO COPY'/
     > ' DRAGON WITHOUT CHARGE PROVIDED THAT THIS'/
     > ' NOTICE IS REPRODUCED ON ALL COPIES.'/
     > ' ECOLE POLYTECHNIQUE DE MONTREAL MAKES NO'/
     > ' WARRANTY, EXPRESS OR IMPLIED, AND ASSUMES'/
     > ' NO LIABILITY OR RESPONSIBILITY FOR THE USE'/
     > ' OF DRAGON.'///)
 6030 FORMAT(//1X,'NORMAL END OF EXECUTION FOR ',A6,I2,'.',I2.2/
     >         1X,'CHECK FOR WARNING IN LISTING'/
     >         1x,'BEFORE ASSUMING YOUR RUN WAS SUCCESSFUL')
 9000 FORMAT('->@ERROR FROM KERNEL IN ',A6,' CODE = ',I10)
      END
